package asteroids;

public class Asteroid {
	
	private static final float speedLimit = 2f;

	protected Position p;
	protected int size;

	public Asteroid() {
		this.p = new Position(0, 0);
		size = 1;
	}
	
	public Asteroid(float x, float y, int s) {
		this(new Position(x, y), s);
	}

	public Asteroid(Position p, int s) {
		this.p = p.clone();
		size = s;
	}
	
	public void move(float x, float y) {
		p.translate(x, y);
	}
	
	public AsteroidExtended[] destroy() {
		int numberOfNewAsteroids = size;
		AsteroidExtended[] newAsteroids = new AsteroidExtended[numberOfNewAsteroids];

		for (int i = 0; i < numberOfNewAsteroids; i++) {
			Position newPos = p.clone();
			newAsteroids[i] = new AsteroidExtended(newPos, size - 1);
		}

		return newAsteroids;
	}
}
