package asteroids;

import java.awt.Color;
import java.awt.Graphics2D;

public class Bullet {
	
	private Position p;
	private Position direction;
	
	private static final float speed = 10f;
	
	public Bullet(Position pos, Position dir) {
		p = pos;
		direction = dir;
	}
	
	public void move(float x, float y) {
		p.translate(x, y);
	}
	
	public boolean isOut() {
		if(p.getX() < 0 || AsteroidsGame.screenX < p.getX()) {
			return true;
		}
		if(p.getY() < 0 || AsteroidsGame.screenY < p.getY()) {
			return true;
		}
		return false;
	}
	
	public void draw(Graphics2D g) {
		Graphics2D g2d = (Graphics2D) g.create();
		g2d.setColor(Color.BLACK);
		
		g2d.translate(p.getX(), p.getY());
		
		g2d.drawOval(0, 0, 2, 2);
		
		g2d.dispose();
	}

	public void advance() {
		
		move(direction.getX() * speed, direction.getY() * speed);
	}

	public boolean collideWithAsteroid(Circle collisionCircle) {
		return collisionCircle.isInside(p);
	}
}
