package asteroids;

import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;

class InputManager extends KeyAdapter {

	private SpaceShipExtended player;
	
	private float rotationMultiplier;
	private float accelerationMultiplier;
	
	private boolean leftDown = false;
	private boolean rightDown = false;
	private boolean downDown = false;
	private boolean upDown = false;
	private boolean spaceDown = false;

	public InputManager(SpaceShipExtended player) {
		this.player = player;
		
		rotationMultiplier = 5f;
		accelerationMultiplier = 5f;
	}

	@Override
	public void keyPressed(KeyEvent e) {

		int keycode = e.getKeyCode();

		switch (keycode) {

		case KeyEvent.VK_LEFT:
			leftDown = true;
			break;

		case KeyEvent.VK_RIGHT:
			rightDown = true;
			break;

		case KeyEvent.VK_DOWN:
			downDown = true;
			break;

		case KeyEvent.VK_UP:
			upDown = true;
			break;

		case KeyEvent.VK_SPACE:
			spaceDown = true;
			break;

		}
	}
	
	@Override
	public void keyReleased(KeyEvent e) {
		
		int keycode = e.getKeyCode();

		switch (keycode) {

		case KeyEvent.VK_LEFT:
			leftDown = false;
			break;

		case KeyEvent.VK_RIGHT:
			rightDown = false;
			break;

		case KeyEvent.VK_DOWN:
			downDown = false;
			break;

		case KeyEvent.VK_UP:
			upDown = false;
			break;

		case KeyEvent.VK_SPACE:
			spaceDown = false;
			break;

		}
	}
	
	public void handleDownKeys() {
		if(leftDown) {
			player.turn(-1f * rotationMultiplier);
		}
		if(rightDown) {
			player.turn(1f * rotationMultiplier);
		}
		if(downDown) {
			player.accelerate(-1f * accelerationMultiplier);
		}
		if(upDown) {
			player.accelerate(1f * accelerationMultiplier);
		}
		if(spaceDown) {
			player.fire();
		}
	}
}
