package asteroids;

public class SpaceShip {
	
	protected Position p;
	protected float rotation;
	
	public SpaceShip(Position position, float r) {
		p = position.clone();
		rotation = r;
	}
	
	public void move(float x, float y) {
		p.translate(x, y);
	}
	
	public void turn(float rot) {
		rotation += rot;
		if(rotation > 360) {
			rotation -= 360;
		}
	}
	
	public void accelerate(float f) {
		float moveY = (float) Math.cos(Math.toRadians(rotation)) * f;
		float moveX = -1 * (float) Math.sin(Math.toRadians(rotation)) * f;
		move(moveX, moveY);
	}
}
