package asteroids;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Polygon;
import java.util.List;

public class SpaceShipExtended extends SpaceShip {
	
	private static int[] shipX = new int[]{0,10,-10};
    private static int[] shipY = new int[]{20,-15,-15};
    
    private Polygon shipDrawable;
    
    private List<Bullet> bulletContainer;
	
	public SpaceShipExtended(float x, float y, List<Bullet> bc) {
		super(new Position(x, y), 0f);
		
		bulletContainer = bc;
		
		shipDrawable = new Polygon(shipX, shipY, shipX.length);
	}

	public void replaceIfNeeded() {
		if(p.getX() < 0) {
			p.translate(AsteroidsGame.screenX, 0);
		} else if(p.getY() < 0) {
			p.translate(0, AsteroidsGame.screenY);
		} else if(AsteroidsGame.screenX < p.getX()) {
			p.translate(-1 * AsteroidsGame.screenX, 0);
		} else if(AsteroidsGame.screenY < p.getY()) {
			p.translate(0, -1 * AsteroidsGame.screenY);
		}
	}

	public void fire() {
		float dirY = (float) Math.cos(Math.toRadians(rotation));
		float dirX = -1 * (float) Math.sin(Math.toRadians(rotation));
		
		Bullet newBullet = new Bullet(p.clone(), new Position(dirX, dirY));
		
		bulletContainer.add(newBullet);
	}
	
	public void draw(Graphics2D g) {
		Graphics2D g2d = (Graphics2D) g.create();
		g2d.setColor(Color.BLACK);
		
		g2d.rotate(Math.toRadians(rotation), p.getX(), p.getY());
		g2d.translate(p.getX(), p.getY());
		
		g2d.draw(shipDrawable);
		g2d.fill(shipDrawable);
		
		g2d.dispose();
	}
}
